#pragma once

#include <maps/libs/xml/include/xml.h>
#include <maps/libs/common/include/pimpl_utils.h>

namespace maps {
namespace wiki {
namespace configs {
namespace editor {

typedef int TZOrder;

class Interactivity
{
public:
    explicit Interactivity(const maps::xml3::Node& node);

    unsigned int hotspotSimplificationTolerance() const;
    double hotspotWidth() const;
    unsigned int geometrySimplificationTolerance() const;
    unsigned int simplificationMinNumberPoints() const;
    TZOrder hotspotZOrder() const;

    MOVABLE_PIMPL_DECLARATIONS(Interactivity)
};

} // editor
} // configs
} // wiki
} // maps
