#pragma once

#include "jsonhelper.h"

#include <maps/libs/pgpool/include/pgpool3.h>
#include <yandex/maps/wiki/revision/objectrevision.h>
#include <yandex/maps/wiki/revision/revisionid.h>
#include <yandex/maps/wiki/revision/revisionsgateway.h>
#include <yandex/maps/wiki/revisionapi/revisionapi.h>

#include <list>
#include <unordered_map>
#include <unordered_set>
#include <string>
#include <vector>

namespace json = maps::json;
namespace revision = maps::wiki::revision;
namespace pgpool = maps::pgpool3;

namespace maps::wiki::revisionapi {

std::list<revision::DBID> deleteObjects(
    pgpool::Pool& pool,
    revision::DBID branchId,
    VerboseLevel verboseLevel,
    const std::vector<revision::DBID>& objectIds,
    revision::UserID userId,
    size_t commitBatchSize);


} // namespace maps::wiki::revisionapi
