#pragma once

#include <string>

namespace maps::wiki::social::feedback::tanker {

namespace fb_desc {

// Keyset 'nmaps/feedback-descriptions'
//
const std::string FB_KEYSET = "feedback-descriptions:";

const std::string ABSENT_ADDRESS_KEY = FB_KEYSET + "absent-address";
const std::string ABSENT_BARRIER_KEY = FB_KEYSET + "absent-barrier";
const std::string ABSENT_CROSSWALK_KEY = FB_KEYSET + "absent-crosswalk";
const std::string ABSENT_ENTRANCE_KEY = FB_KEYSET + "absent-entrance";
const std::string ABSENT_FENCE_KEY = FB_KEYSET + "absent-fence";
const std::string ABSENT_GATE_KEY = FB_KEYSET + "absent-gate";
const std::string ABSENT_OBJECT_KEY = FB_KEYSET + "absent-object";
const std::string ABSENT_PARKING_ENTRANCES_KEY = FB_KEYSET + "absent-parking-entrances";
const std::string ABSENT_PARKING_KEY = FB_KEYSET + "absent-parking";
const std::string ABSENT_ROAD_KEY = FB_KEYSET + "absent-road";
const std::string ABSENT_TRAFFIC_LIGHT_KEY = FB_KEYSET + "absent-traffic-light";
const std::string AD_DUPLICATE_ROAD_NAMES_KEY = FB_KEYSET + "validator-message-ad-duplicate-road-names";
const std::string ADDR_CORRECTION_KEY = FB_KEYSET + "addr-correction";
const std::string ADDR_OUTSIDE_ADM_UNIT_KEY = FB_KEYSET + "validator-message-addr-outside-adm-unit";
const std::string ADDR_OUTSIDE_BUILDING_KEY = FB_KEYSET + "validator-message-addr-outside-building";
const std::string ADDR_POS_CORRECTION_KEY = FB_KEYSET + "addr-pos-correction";
const std::string ADDR_TOO_FAR_FROM_ROAD_KEY = FB_KEYSET + "validator-message-addr-too-far-from-road";
const std::string ADDR_WRONG_POS_KEY = FB_KEYSET + "addr-wrong-position";
const std::string ADDRESS_UNKNOWN_KEY = FB_KEYSET + "address-unknown";
const std::string AUTOMOTIVE_SIGN_DISAPPEARANCE_KEY = FB_KEYSET + "automotive-sign-disappearance";
const std::string BARRIER_WRONG_POS_KEY = FB_KEYSET + "barrier-wrong-position";
const std::string BUILDING_DEMOLISHED_KEY = FB_KEYSET + "building-demolished";
const std::string CHANGE_PARKING_TO_FREE_KEY = FB_KEYSET + "change-parking-to-free";
const std::string CHANGE_PARKING_TO_TOLL_KEY = FB_KEYSET + "change-parking-to-toll";
const std::string CONSTRUCTIVE_SIGN_DISAPPEARANCE_KEY = FB_KEYSET + "constructive-sign-disappearance";
const std::string DELETE_ENTRANCE_KEY = FB_KEYSET + "delete-entrance";
const std::string DIMENSIONS_LIMITING_SIGN_KEY = FB_KEYSET + "dimensions-limiting-sign";
const std::string DOUBLE_SPACE_IN_NAME_KEY = FB_KEYSET + "validator-message-double-space-in-name";
const std::string DUPLICATE_ADDRESS_POINT_NAMES_KEY = FB_KEYSET + "validator-message-duplicate-address-point-names";
const std::string ENTRANCE_CORRECTION_KEY = FB_KEYSET + "entrance-correction";
const std::string ENTRANCE_WRONG_POS_KEY = FB_KEYSET + "entrance-wrong-position";
const std::string FIX_BY_PHOTO_KEY = FB_KEYSET + "fix-by-photo";
const std::string GATE_WRONG_POS_KEY = FB_KEYSET + "gate-wrong-position";
const std::string HEAVY_VEHICLE_SIGN_DISAPPEARANCE_KEY = FB_KEYSET + "heavy-vehicle-sign-disappearance";
const std::string ILLEGAL_LETTER_FOR_NAME_LANG_KEY = FB_KEYSET + "validator-message-illegal-letter-for-name-lang";
const std::string ILLEGAL_SYMBOL_IN_POI_NAME_KEY = FB_KEYSET + "validator-message-illegal-symbol-in-poi-name";
const std::string INDOOR_POI_MISSED_KEY = FB_KEYSET + "indoor-poi-missed";
const std::string LOCATION_WRONG_POS_KEY = FB_KEYSET + "location-wrong-position";
const std::string MANDATORY_DIR_TRAFFIC_SIGN_KEY = FB_KEYSET + "mandatory-dir-traffic-sign";
const std::string MAX_NAME_LENGTH_EXCEEDED_KEY = FB_KEYSET + "validator-message-max-name-length-exceeded";
const std::string MULTIPLE_NON_SYNONYM_NAMES_KEY = FB_KEYSET + "validator-message-multiple-non-synonym-names";
const std::string NAME_BEGINS_WITH_SPACE_KEY = FB_KEYSET + "validator-message-name-begins-with-space";
const std::string NAME_WITH_ALL_CAPITAL_LETTERS_KEY = FB_KEYSET + "validator-message-name-with-all-capital-letters";
const std::string NEW_ADDRESS_KEY = FB_KEYSET + "new-address";
const std::string NO_BUILDING_HERE_KEY = FB_KEYSET + "no-building-here";
const std::string NO_NEEDED_PARKING_FREE_KEY = FB_KEYSET + "no-needed-parking-free";
const std::string NO_NEEDED_PARKING_TOLL_KEY = FB_KEYSET + "no-needed-parking-toll";
const std::string NO_NEEDED_PARKING_TYPE_KEY = FB_KEYSET + "no-needed-parking-type";
const std::string NO_PUBLIC_TRANSPORT_STOP_HERE_KEY = FB_KEYSET + "no-public-transport-stop-here";
const std::string NON_LOCAL_NAME_FOR_LOCAL_LANG_KEY = FB_KEYSET + "validator-message-non-local-name-for-local-lang";
const std::string OFFICIAL_NAME_MISSING_KEY = FB_KEYSET + "validator-message-official-name-missing";
const std::string ONEWAY_TRAFFIC_SIGN_KEY = FB_KEYSET + "oneway-traffic-sign";
const std::string OTHER_AUTO_KEY = FB_KEYSET + "other-auto";
const std::string OTHER_AUTO_ANNOTATIONS_KEY = FB_KEYSET + "other-auto-annotations";
const std::string OTHER_AUTO_BAD_PAVEMENT_KEY = FB_KEYSET + "other-auto-bad-pavement";
const std::string OTHER_BICYCLE_KEY = FB_KEYSET + "other-bicycle";
const std::string OTHER_INDOOR_KEY = FB_KEYSET + "other-indoor";
const std::string OTHER_MAP_KEY = FB_KEYSET + "other-map";
const std::string OTHER_MASSTRANSIT_KEY = FB_KEYSET + "other-masstransit";
const std::string OTHER_PEDESTRIAN_KEY = FB_KEYSET + "other-pedestrian";
const std::string OTHER_POI_KEY = FB_KEYSET + "other-poi";
const std::string OTHER_TOPONYM_KEY = FB_KEYSET + "other-toponym";
const std::string OTHER_TRUCK_KEY = FB_KEYSET + "other-truck";
const std::string PARKING_SIGN_DISAPPEARANCE_KEY = FB_KEYSET + "parking-sign-disappearance";
const std::string PARKING_TERRITORY_IS_NOT_CONNECTED_TO_PARKING_LOT_KEY = FB_KEYSET + "validator-message-parking-territory-is-not-connected-to-parking-lot";
const std::string PEDESTRIAN_SIGN_DISAPPEARANCE_KEY = FB_KEYSET + "pedestrian-sign-disappearance";
const std::string PROHIBITED_FORWARD_MOVEMENT = FB_KEYSET + "prohibited-forward-movement";
const std::string PROHIBITED_LEFT_TURN = FB_KEYSET + "prohibited-left-turn";
const std::string PROHIBITED_PATH = FB_KEYSET + "prohibited-path";
const std::string PROHIBITED_RIGHT_TURN = FB_KEYSET + "prohibited-right-turn";
const std::string PROHIBITED_TURN_SIGN_KEY = FB_KEYSET + "prohibited-turn-sign";
const std::string PROHIBITED_UTURN = FB_KEYSET + "prohibited-uturn";
const std::string PUBLIC_TRANSPORT_SIGN_DISAPPEARANCE_KEY = FB_KEYSET + "public-transport-sign-disappearance";
const std::string REMOVE_BARRIER_KEY = FB_KEYSET + "remove-barrier";
const std::string REMOVE_GATE_KEY = FB_KEYSET + "remove-gate";
const std::string REMOVE_OBJECT_KEY = FB_KEYSET + "remove-object";
const std::string REMOVE_STOP_KEY = FB_KEYSET + "remove-stop";
const std::string ROUTE_CORRECTION_KEY = FB_KEYSET + "route-correction";
const std::string ROUTE_ERROR_KEY = FB_KEYSET + "route-error";
const std::string ROUTE_GAP_KEY = FB_KEYSET + "route-gap";
const std::string ROUTE_LOST_DETAILED_KEY = FB_KEYSET + "route-lost-detailed";
const std::string ROUTE_LOST_KEY = FB_KEYSET + "route-lost";
const std::string ROUTE_NO_DRIVEWAY_KEY = FB_KEYSET + "route-no-driveway";
const std::string ROUTE_NO_PASSAGEWAY_KEY = FB_KEYSET + "route-no-passageway";
const std::string ROUTE_NOROAD_KEY = FB_KEYSET + "route-no-road";
const std::string ROUTE_OTHER_KEY = FB_KEYSET + "route-other";
const std::string ROUTE_POOR_CONDITION_KEY = FB_KEYSET + "route-poor-condition";
const std::string ROUTE_TURN_PROHIBITED_KEY = FB_KEYSET + "route-turn-prohibited";
const std::string SETTLEMENT_SCHEME_KEY = FB_KEYSET + "settlement-scheme";
const std::string SPEED_BUMP_SIGN_AHEAD_KEY = FB_KEYSET + "speed-bump-sign-ahead";
const std::string SPEED_BUMP_SIGN_KEY = FB_KEYSET + "speed-bump-sign";
const std::string SPEED_LIMIT_SIGN_DISAPPEARANCE_KEY = FB_KEYSET + "speed-limit-sign-disappearance";
const std::string STOP_WRONG_POS_KEY = FB_KEYSET + "stop-wrong-position";
const std::string SUBWAY_NOT_FOUND_KEY = FB_KEYSET + "subway-not-found";
const std::string SUBWAY_OTHER_KEY = FB_KEYSET + "subway-other";
const std::string SUBWAY_WRONG_NAME_AND_POSITION_KEY = FB_KEYSET + "subway-wrong-name-and-position";
const std::string SUBWAY_WRONG_NAME_KEY = FB_KEYSET + "subway-wrong-name";
const std::string SUBWAY_WRONG_POSITION_KEY = FB_KEYSET + "subway-wrong-position";
const std::string SUGGESTED_ACTION_CREATE_POI_KEY = FB_KEYSET + "suggested-action-create-poi";
const std::string SUGGESTED_ACTION_DELETE_KEY = FB_KEYSET + "suggested-action-delete";
const std::string SUGGESTED_ACTION_MODIFY_KEY = FB_KEYSET + "suggested-action-modify";
const std::string SUGGESTED_ACTION_VERIFY_POSITION_KEY = FB_KEYSET + "suggested-action-verify-position";
const std::string TRAFFIC_CIRCLE_SIGN_KEY = FB_KEYSET + "traffic-circle-sign";
const std::string TRAFFIC_LANE_SIGN_KEY = FB_KEYSET + "traffic-lane-sign";
const std::string TRAFFIC_LANES_SIGN_DISAPPEARANCE_KEY = FB_KEYSET + "traffic-lanes-sign-disappearance";
const std::string TRAFFIC_PROHIBITED_SIGN_KEY = FB_KEYSET + "traffic-prohibited-sign";
const std::string TRUCKS_MANEUVER_RESTRICTION_SIGN_KEY = FB_KEYSET + "trucks-maneuver-restriction-sign";
const std::string TRUCKS_PROHIBITED_SIGN_KEY = FB_KEYSET + "trucks-prohibited-sign";
const std::string TRUCKS_SPEED_LIMIT_SIGN_KEY = FB_KEYSET + "trucks-speed-limit-sign";
const std::string UNKNOWN_NAME_LANG_KEY = FB_KEYSET + "validator-message-unknown-name-lang";
const std::string UNNAMED_POI_KEY = FB_KEYSET + "validator-message-unnamed-poi";
const std::string USER_COMMENT_KEY = FB_KEYSET + "user-comment";
const std::string VALIDATION_SIMPLE_KEY = FB_KEYSET + "validation-simple";
const std::string VALIDATION_TWO_OBJECTS_KEY = FB_KEYSET + "validation-two-objects";
const std::string VISIT_INTERNAL_ERROR_KEY = FB_KEYSET + "validator-message-visit-internal-error";
const std::string WEIGHT_LIMITING_SIGN_KEY = FB_KEYSET + "weight-limiting-sign";
const std::string WRONG_LINES_SET = FB_KEYSET + "wrong-lines-set";
const std::string WRONG_NAME_KEY = FB_KEYSET + "wrong-name";
const std::string WRONG_PARKING_TYPE_KEY = FB_KEYSET + "wrong-parking-type";
const std::string WRONG_ROAD_DIR_KEY = FB_KEYSET + "wrong-road-direction";
const std::string WRONG_SPEEDLIMIT_KEY = FB_KEYSET + "wrong-speedlimit";

} //namespace fb_desc

namespace attr_values {

// Keyset 'nmaps/attr-values'
//
const std::string ATTRS_KEYSET = "attr-values:";

const std::string RDEL_ONEWAY_BOTH_KEY = ATTRS_KEYSET + "rd_el-oneway__b";
const std::string RDEL_ONEWAY_FROM_KEY = ATTRS_KEYSET + "rd_el-oneway__f";
const std::string RDEL_ONEWAY_TO_KEY = ATTRS_KEYSET + "rd_el-oneway__t";

const std::string LINEAR_PARKING_FREE_KEY =
    ATTRS_KEYSET + "urban_roadnet_parking_lot_linear-ft_type_id__2001";
const std::string LINEAR_PARKING_TOLL_KEY =
    ATTRS_KEYSET + "urban_roadnet_parking_lot_linear-ft_type_id__2002";
const std::string LINEAR_PARKING_RESTRICT_KEY =
    ATTRS_KEYSET + "urban_roadnet_parking_lot_linear-ft_type_id__2003";
const std::string LINEAR_PARKING_PROHIBIT_KEY =
    ATTRS_KEYSET + "urban_roadnet_parking_lot_linear-ft_type_id__2004";

} //namespace attr_values

// Non-translatable params
//
const std::string COMMENT = "comment";
const std::string CONFIRMING_SIGN_NOT_FOUND = "confirmingSignNotFound";
const std::string CORRECT_HOUSE = "correctHouse";
const std::string CORRECT_NAME = "correctName";
const std::string CORRECT_ADDRESS = "correctAddress";
const std::string CORRECT_PARKING_TYPE = "correctParkingType";
const std::string CORRECT_ROAD_DIR = "correctRoadDirection";
const std::string CORRECT_SPEED_LIMIT = "correctSpeedLimit";
const std::string CORRECT_STREET = "correctStreet";
const std::string COUNT_TRACKS = "countTracks";
const std::string COUNT_TRACK_RIPS = "countTrackRips";
const std::string CURRENT_NAME = "currentName";
const std::string CURRENT_PARKING_TYPE = "currentParkingType";
const std::string CURRENT_SPEED_LIMIT = "currentSpeedLimit";
const std::string DIRECTION = "direction";
const std::string ENTRANCE_NAME = "entranceName";
const std::string ADDRESS_HOUSE_NUMBER = "addressHouseNumber";
const std::string MESSAGE = "message";
const std::string NAME = "name";
const std::string OBJECT_ONE = "objectOne";
const std::string OBJECT_TWO = "objectTwo";
const std::string PROHIBITED = "prohibited";
const std::string PROHIBITED_PATH_URL = "prohibitedPathUrl";
const std::string PHOTO_URLS = "photoUrls";
const std::string PROBABILITY = "probability";
const std::string ROAD_NAME = "roadName";
const std::string ROUTE_GAP_LINK = "routeGapLink";
const std::string ROUTE_LOST_LINK = "routeLostLink";
const std::string ROUTE_LOST_LOCAL_LINK = "routeLostLocalLink";
const std::string ROUTE_LOST_LOCAL_USER_LINK = "routeLostLocalUserLink";
const std::string ROUTE_LOST_LOCAL_NAVI_LINK = "routeLostLocalNaviLink";
const std::string ROUTE_LOST_GLOBAL_NAVI_LINK = "routeLostGlobalNaviLink";
const std::string ROUTE_LOSTS_PER_DAY = "routeLostsPerDay";
const std::string TRACKS_PER_DAY = "tracksPerDay";
const std::string TRUCK = "truck";
const std::string USER_COMMENT = "userComment";
const std::string VALIDATOR_DESCRIPTION = "validatorDescription";
const std::string X_CORRECT = "xCorrect";
const std::string X_WRONG = "xWrong";
const std::string Y_CORRECT = "yCorrect";
const std::string Y_WRONG = "yWrong";

} //namespace maps::wiki::social::feedback::tanker
