#pragma once

#include <yandex/maps/wiki/topo/common.h>

#include <maps/libs/geolib/include/point.h>
#include <maps/libs/geolib/include/polyline.h>

#include <boost/optional.hpp>

#include <memory>

namespace maps {
namespace wiki {
namespace topo {

class CacheImpl;
struct Callbacks;

class Operation {
public:
    virtual ~Operation() {}

protected:
    Operation(
            const Callbacks& callbacks,
            CacheImpl& cache)
        : callbacks_(callbacks)
        , cache_(cache)
    {}

    const Callbacks& callbacks_;
    CacheImpl& cache_;
};

} // namespace topo
} // namespace wiki
} // namespace maps
