#pragma once

#include <yandex/maps/wiki/validator/common.h>
#include <yandex/maps/wiki/validator/objects/adm_unit_common.h>
#include <yandex/maps/wiki/validator/objects/name.h>

namespace maps::wiki::validator {

class AdmUnitSubst : public AdmUnitCommon
{
public:
    AdmUnitSubst(
        TId id,
        const AttrMap& attributes,
        const Relations& masters,
        const Relations& slaves);

    // Id of substituted adm unit from general hierarchy
    TId generalHierarchyId() const
    { return generalHierarchyId_; }

    bool isVirtual() const
    { return isVirtual_; }

private:
    TId generalHierarchyId_;
    bool isVirtual_;
};

} // namespace maps::wiki::validator
