OWNER(g:maps-nmaps)

LIBRARY()

ADDINCL(
    GLOBAL maps/libs/geolib/include
    GLOBAL maps/wikimap/mapspro/libs/validator/include
)

PEERDIR(
    contrib/restricted/boost/libs
    contrib/libs/geos
    contrib/libs/libpqxx
    maps/libs/chrono
    maps/libs/common
    maps/libs/coverage
    maps/libs/geolib
    maps/libs/introspection
    maps/libs/log8
    maps/libs/pgpool
    maps/libs/st
    maps/libs/ymapsdf
    maps/wikimap/mapspro/libs/configs_editor
    maps/wikimap/mapspro/libs/common
    maps/wikimap/mapspro/libs/dbutils
    maps/wikimap/mapspro/libs/geom_tools
    maps/wikimap/mapspro/libs/revision
    maps/wikimap/mapspro/libs/threadutils
    maps/wikimap/mapspro/libs/types
)

SRCS(
    common/categories_list.cpp
    common/exception.cpp
    common/utils.cpp
    content/geom_objects_view.cpp
    content/objects_collections_tuple.cpp
    content/objects_view.cpp
    loader/category_revisions_loader.cpp
    loader/data_source.cpp
    loader/db_gateway.cpp
    loader/helper_loaders.cpp
    loader/important_regions.cpp
    loader/object_ids_loaders.cpp
    loader/relations_cardinality_checks.cpp
    loader/revisions_loaders.cpp
    objects/address_point.cpp
    objects/adm_unit.cpp
    objects/adm_unit_common.cpp
    objects/adm_unit_subst.cpp
    objects/arrival_point.cpp
    objects/building.cpp
    objects/building_complex.cpp
    objects/center.cpp
    objects/condition.cpp
    objects/condition_lane.cpp
    objects/cond_annotation.cpp
    objects/cond_toll.cpp
    objects/cond_ds.cpp
    objects/cond_ds_el.cpp
    objects/contour_feature.cpp
    objects/contour_linear_feature.cpp
    objects/edge.cpp
    objects/face.cpp
    objects/flat_range.cpp
    objects/indoor_level.cpp
    objects/indoor_plan.cpp
    objects/junction.cpp
    objects/linear_feature.cpp
    objects/name.cpp
    objects/parking_controlled_zone.cpp
    objects/parking_lot.cpp
    objects/polyline_feature.cpp
    objects/poi.cpp
    objects/poi_entrance.cpp
    objects/point_feature.cpp
    objects/polygon_feature.cpp
    objects/region.cpp
    objects/road.cpp
    objects/road_element.cpp
    objects/road_marking_linear.cpp
    objects/road_marking_point.cpp
    objects/road_marking_polygonal.cpp
    objects/road_surface.cpp
    objects/schedule.cpp
    objects/service_polygon.cpp
    objects/traffic_light.cpp
    objects/transport_airport.cpp
    objects/transport_boarding.cpp
    objects/transport_element.cpp
    objects/transport_line.cpp
    objects/transport_metro_exit.cpp
    objects/transport_metro_station.cpp
    objects/transport_operator.cpp
    objects/transport_passageway.cpp
    objects/transport_stop.cpp
    objects/transport_thread.cpp
    objects/transport_thread_stop.cpp
    objects/transport_transition.cpp
    objects/vehicle_restriction.cpp
    objects/vehicle_restriction_common.cpp
    storage/exclusions_gateway.cpp
    storage/exclusions_set.cpp
    storage/helpers.cpp
    storage/issue_creator.cpp
    storage/message_attributes_filter.cpp
    storage/messages_writer.cpp
    storage/results_gateway.cpp
    storage/stored_message_data.cpp
    area_of_interest.cpp
    changed_objects.cpp
    check.cpp
    check_context.cpp
    message.cpp
    result.cpp
    task_context.cpp
    task_messages.cpp
    validator_config.cpp
    validator.cpp
)

END()

RECURSE(
    test_checks
    tests
)
