CREATE OR REPLACE FUNCTION vrevisions_stable.bbox_parts()
  RETURNS geometry[] AS
$BODY$
BEGIN
  RETURN ARRAY[
    ST_SetSRID(ST_MakeBox2D(ST_Point(2000001,4500001), ST_Point(7000000,147687969)),3395),
    ST_SetSRID(ST_MakeBox2D(ST_Point(7000001,4500001), ST_Point(20037483,147687969)),3395),
    ST_SetSRID(ST_MakeBox2D(ST_Point(-3000000,4500001), ST_Point(900000,147687969)),3395),
    ST_SetSRID(ST_MakeBox2D(ST_Point(900001,4500001), ST_Point(2000000,147687969)),3395),
    ST_SetSRID(ST_MakeBox2D(ST_Point(-20037483,-147687969), ST_Point(-3000001,147687969)),3395),
    ST_SetSRID(ST_MakeBox2D(ST_Point(-3000000,-147687969), ST_Point(20037483,4500000)),3395)
  ];
END;
$BODY$
  LANGUAGE plpgsql IMMUTABLE
  COST 1;

SELECT vrevisions.for_vrevisions('
CREATE OR REPLACE FUNCTION bbox_parts()
  RETURNS geometry[] AS
$BODY$
BEGIN
  RETURN ARRAY[
    ST_SetSRID(ST_MakeBox2D(ST_Point(2000001,4500001), ST_Point(7000000,147687969)),3395),
    ST_SetSRID(ST_MakeBox2D(ST_Point(7000001,4500001), ST_Point(20037483,147687969)),3395),
    ST_SetSRID(ST_MakeBox2D(ST_Point(-3000000,4500001), ST_Point(900000,147687969)),3395),
    ST_SetSRID(ST_MakeBox2D(ST_Point(900001,4500001), ST_Point(2000000,147687969)),3395),
    ST_SetSRID(ST_MakeBox2D(ST_Point(-20037483,-147687969), ST_Point(-3000001,147687969)),3395),
    ST_SetSRID(ST_MakeBox2D(ST_Point(-3000000,-147687969), ST_Point(20037483,4500000)),3395)
  ];
END;
$BODY$
  LANGUAGE plpgsql IMMUTABLE
  COST 1;
');

SELECT vrevisions.for_vrevisions_trunk_stable('
UPDATE objects_a16_part6 SET part=NULL WHERE get_part(the_geom)!=6;
UPDATE objects_l12_part6 SET part=NULL WHERE get_part(the_geom)!=6;
UPDATE objects_p16_part6 SET part=NULL WHERE get_part(the_geom)!=6;

UPDATE objects_a7 SET part=NULL WHERE part=6 AND get_part(the_geom)!=6;
UPDATE objects_a8 SET part=NULL WHERE part=6 AND get_part(the_geom)!=6;
UPDATE objects_a10 SET part=NULL WHERE part=6 AND get_part(the_geom)!=6;
UPDATE objects_a12 SET part=NULL WHERE part=6 AND get_part(the_geom)!=6;
UPDATE objects_a14 SET part=NULL WHERE part=6 AND get_part(the_geom)!=6;

UPDATE objects_l9 SET part=NULL WHERE part=6 AND get_part(the_geom)!=6;
UPDATE objects_l10 SET part=NULL WHERE part=6 AND get_part(the_geom)!=6;

UPDATE objects_p7 SET part=NULL WHERE part=6 AND get_part(the_geom)!=6;
UPDATE objects_p8 SET part=NULL WHERE part=6 AND get_part(the_geom)!=6;
UPDATE objects_p10 SET part=NULL WHERE part=6 AND get_part(the_geom)!=6;
UPDATE objects_p12 SET part=NULL WHERE part=6 AND get_part(the_geom)!=6;
UPDATE objects_p14 SET part=NULL WHERE part=6 AND get_part(the_geom)!=6;
');
