# Процесс детектирования зданий на спутниковых снимках

Выполняет детектирование зданий на выбранных регионах, сохраняет в YT хранилище и запускает процессы валидации.

[Кубик в Нирване](https://nirvana.yandex-team.ru/operation/85b0ef12-9b78-4d4e-9146-b5c2927e17da "Кубик в Нирване")

## Описание параметров
1. yt_config - путь до json файла с настройками YT хранилища
2. detector_config - путь до json файла с настройками детектора
3. auto_toloker_config - путь до json файла с настройками валидатора
4. mpro_config - путь до xml файла с настройками доступа до базы MPRO
5. hitman_token - токен для доступа к Хитману. Получить можно по адресу: auth.yandex-team.ru
6. use_gpu - включение GPU

## Шаги процесса
1. Загружаем кофиги
2. Создаем Hitman и YT клиенты
3. Подключаемся к YT хранилищу
4. Загружаем регионы из MPRO
5. Удаляем регионы, у которых is_active == false
6. Загружаем последний релиз со спутниковой фабрики
7. Удаляем все регионы, которые уже были обработаны с этим релизом
8. Удаляем все регионы, которые в данный момент обрабатываются в Хитмане
9. Проверяем наличие ошибок в Хитман процессах. Если ошибки есть, то процесс прекращается. Чтобы он выполнился, необходимо устранить ошибки
10. Загружаем все релизы из спутниковой фабрики и YT хранилища
11. Находим покрытие нужным зумом
12. Пересекаем регионы со спутниковым покрытием
13. Удаляем регионы, которые не пересекаются с покрытием
14. Пересекаем регионы с новыми релизами
15. Удаляем регионы, которые не пересекаются с новыми релизами
16. Начинаем процесс детектирования
17. Фильтруем дороги, дома, зоны, которые находятся в указанных регионах
18. Создаем клетки с этими объектами
19. В полученных клетках запускает детектор
20. На полученных зданиях запускаем автоматический валидатор
21. Удаляем здания, которые сильно пересекаются со зданиями, которые уже были ранее отклонены толокерами и асессорами
22. Выделяем здания для каждого региона, сохраняем результаты в хранилище
23. Запускаем необходимый процесс валидации
