#!/usr/bin/env python
# -*- coding: utf-8 -*-

import json
import argparse


def get_blds_num(json_path):
    with open(json_path, "r") as f:
        return len(json.load(f))


def get_mds_url(json_path):
    with open(json_path, "r") as f:
        return json.load(f)[0]["downloadUrl"]


def get_budget(json_path):
    with open(json_path, "r") as f:
        return json.load(f)[0]["budget"]


def create_comment(args):
    # extract values from json
    accepted_blds_number = get_blds_num(args.accepted_blds)
    accepted_blds_viewer = get_mds_url(args.accepted_viewer)
    rejected_blds_number = get_blds_num(args.rejected_blds)
    rejected_blds_viewer = get_mds_url(args.rejected_viewer)
    unknown_blds_number = get_blds_num(args.unknown_blds)
    blds_number = accepted_blds_number + rejected_blds_number + unknown_blds_number
    budget = get_budget(args.budget)
    # create text
    text = "Валидация толокерами завершена.\n\n"
    text = text + "Результаты валидации:\n"
    text = text + "* Количество провалидированных зданий: {}.\n".format(blds_number)
    text = text + "* Количество **!!(зел)принятых!!** зданий: {} ((({} Посмотреть))).\n".format(accepted_blds_number, accepted_blds_viewer)
    text = text + "* Количество **!!отклоненных!!** зданий: {} ((({} Посмотреть))).\n".format(rejected_blds_number, rejected_blds_viewer)
    text = text + "* Затраченные средства: {}$".format(budget)
    return text


def main():
    parser = argparse.ArgumentParser("Create tolokers results comment")
    parser.add_argument("--accepted_blds", required=True)
    parser.add_argument("--accepted_viewer", required=True)
    parser.add_argument("--rejected_blds", required=True)
    parser.add_argument("--rejected_viewer", required=True)
    parser.add_argument("--unknown_blds", required=True)
    parser.add_argument("--budget", required=True)
    parser.add_argument("--output", required=True)
    args = parser.parse_args()

    with open(args.output, "w") as f:
        f.write(create_comment(args))


if __name__ == "__main__":
    main()
