#pragma once

#include <maps/wikimap/mapspro/services/editor/src/common.h>
#include <maps/wikimap/mapspro/libs/controller/include/basecontroller.h>

#include <yandex/maps/wiki/filters/common.h>

namespace maps {
namespace wiki {

class DeleteFilter;
template<>
struct controller::ResultType<DeleteFilter>
{
    std::string taskName;
    Token token;
};

class DeleteFilter : public controller::BaseController<DeleteFilter>
{
public:
    struct Request
    {
        const TUid uid;
        const filters::TFilterId filterId;
    };

    explicit DeleteFilter(const Request& request);

    virtual std::string printRequest() const;

protected:
    virtual void control();


private:
    const Request request_;

};

} // namespace wiki
} // namespace maps
