#include <maps/wikimap/mapspro/services/editor/src/objects/complex_object.h>
#include <maps/wikimap/mapspro/services/editor/src/exception.h>
#include <maps/wikimap/mapspro/services/editor/src/collection.h>
#include <maps/wikimap/mapspro/services/editor/src/objectvisitor.h>
#include <maps/wikimap/mapspro/services/editor/src/configs/config.h>
#include <maps/wikimap/mapspro/services/editor/src/objects_cache.h>

#include <maps/libs/log8/include/log8.h>

#include <boost/format.hpp>
#include <cmath>


namespace maps {
namespace wiki {

ComplexObject::ComplexObject(const TRevisionId& id, ObjectsCache& cache)
    : GeoObject(id, cache)
{}

void
ComplexObject::generalize(Transaction&)
{}

void
ComplexObject::applyVisitor(ObjectVisitor& visitor) const
{
    visitor.visitComplexObject(this);
}

void
ComplexObject::applyProcessor(ObjectProcessor& processor)
{
    processor.processComplexObject(this);
}

} // namespace wiki
} // namespace maps
