#pragma once

#include <maps/wikimap/mapspro/services/editor/src/common.h>
#include <maps/wikimap/mapspro/services/editor/src/objects/relation_object.h>

namespace maps {
namespace wiki {
namespace views {

class RelationViewObject
{
public:
    RelationViewObject(Transaction& work, const RelationObject* obj);

    static const std::string tableName;
    static const std::string fields;
    static const std::string insertFunction;
    static const std::string updateFunction;
    static const std::string deleteFunction;

    TOid id() const { return id_; }

    std::string valueStr() const;
    std::string setStr() const;

private:
    TOid id_;
    TCommitId commitId_;
    std::string domainAttrs_;
    TOid masterId_;
    TOid slaveId_;
};

} // namespace views
} // namespace wiki
} // namespace maps
