OWNER(g:maps-mrc)

UNITTEST()

ADDINCL(
    contrib/libs/cairo/src
    contrib/libs/opencv/include
)

PEERDIR(
    contrib/restricted/boost/libs
    library/cpp/testing/gmock_in_unittest
    contrib/libs/libpqxx
    maps/doc/proto/converters/geolib
    maps/doc/proto/yandex/maps/proto/mobile_config/mapkit2
    maps/libs/common
    maps/libs/concurrent
    maps/libs/chrono
    maps/libs/img
    maps/libs/introspection
    maps/libs/json
    maps/libs/log8
    maps/libs/pgpool
    maps/libs/pgpool3utils
    maps/libs/process
    maps/libs/tile
    maps/renderer/libs/data_sets/data_set_test_util
    maps/infra/yacare
    maps/wikimap/mapspro/libs/common
    maps/wikimap/mapspro/libs/acl
    maps/wikimap/mapspro/libs/unittest
    maps/wikimap/mapspro/services/mrc/browser/lib
    maps/wikimap/mapspro/services/mrc/libs/blackbox_client
    maps/wikimap/mapspro/services/mrc/libs/common
    maps/wikimap/mapspro/services/mrc/libs/db
    maps/wikimap/mapspro/services/mrc/libs/privacy
    maps/wikimap/mapspro/services/mrc/libs/unittest
    maps/wikimap/mapspro/services/mrc/long_tasks/export_gen/lib
    maps/wikimap/mapspro/services/mrc/libs/ugc_event_logger
)

DEPENDS(
    maps/data/test/graph4
    maps/data/test/geoid
    maps/tools/json-validator
    maps/wikimap/mapspro/services/mrc/libs/unittest/stubs/mds
    maps/wikimap/mapspro/services/mrc/browser/tests/s3mds-stub
)

DATA(
    arcadia/maps/doc/schemas/renderer/source/sources/mrce
    arcadia/maps/doc/schemas/renderer/source/sources/mrcpe
    arcadia/maps/libs/auth/tests/tvmtool.recipe.conf
    arcadia/maps/wikimap/mapspro/cfg/services/
    arcadia/maps/wikimap/mapspro/libs/revision/sql/postgres_upgrade.sql
    arcadia/maps/wikimap/mapspro/schemas/mrc/browser
    arcadia/maps/wikimap/mapspro/schemas/mrc/toloka/classification/
    arcadia/maps/wikimap/mapspro/services/mrc/migrations
    arcadia/maps/wikimap/mapspro/services/mrc/browser/icons
    arcadia/maps/wikimap/mapspro/services/mrc/browser/tests
    arcadia/maps/wikimap/mapspro/services/mrc/browser/tests/expected
)

SRCS(
    common.cpp
    dataset_holder_tests.cpp
    feature_api_tests.cpp
    feature_api_fb_tests.cpp
    graph_coverage_explorer_tests.cpp
    log_ugc_events_tests.cpp
    panorama_api_tests.cpp
    permission_checker_tests.cpp
    photo_api_tests.cpp
    rendering_tests.cpp
    service_api_tests.cpp
    tests.cpp
)

SIZE(MEDIUM)
INCLUDE(${ARCADIA_ROOT}/maps/pylibs/recipes/postgres/recipe.inc)
INCLUDE(${ARCADIA_ROOT}/library/recipes/tvmtool/recipe.inc)
USE_RECIPE(library/recipes/tvmtool/tvmtool maps/libs/auth/tests/tvmtool.recipe.conf)

END()

RECURSE(
    s3mds-stub
)
