#pragma once

#include <maps/wikimap/mapspro/services/mrc/libs/sensors_feature_positioner/include/types.h>

namespace maps::mrc::sensors_feature_positioner {

// Calculates rays intersections, filters good intersections and
// groups close intersections.
// Return groups of intersections, where each group describes single object.
std::vector<ObjectIntersections> locateObjectsUsingIntersections(Rays rays);

// returns aggregated position of all intersection (intersections with
// almost parallel rays have small weight)
geolib3::Point2 aggregatedMercatorPosition(const ObjectIntersections& objectIntersections);

} // namespace maps::mrc::sensors_feature_positioner
