#pragma once

#include <maps/wikimap/mapspro/services/mrc/libs/toloka_manager/include/task.h>
#include <maps/wikimap/mapspro/services/mrc/libs/toloka_manager/include/detection.h>

#include <string>
#include <vector>

namespace maps::mrc::toloka {

/**
 * Task traits for detection house numbers on image
 */
struct HouseNumberDetectionTaskTraits {
    using InputType = DetectionInput;
    using OutputType = DetectionOutput;
    static constexpr auto DB_TASK_TYPE = DbTaskType::HouseNumberDetection;
};

using HouseNumberDetectionTask = Task<HouseNumberDetectionTaskTraits>;
using HouseNumberDetectionTasks = std::vector<HouseNumberDetectionTask>;

} // namespace maps::mrc::toloka
