#pragma once

#include <maps/wikimap/mapspro/services/mrc/libs/toloka_manager/include/task.h>
#include <maps/wikimap/mapspro/services/mrc/libs/toloka_manager/include/detection.h>

#include <string>
#include <vector>

namespace maps::mrc::toloka {

/**
 * Task traits for detection traffic lights on image
 */
struct TrafficLightDetectionTaskTraits {
    using InputType = DetectionInput;
    using OutputType = DetectionOutput;
    static constexpr auto DB_TASK_TYPE = DbTaskType::TrafficLightDetection;
};

using TrafficLightDetectionTask = Task<TrafficLightDetectionTaskTraits>;
using TrafficLightDetectionTasks = std::vector<TrafficLightDetectionTask>;

} // namespace maps::mrc::toloka
