#pragma once

#include <maps/libs/sql_chemistry/include/filter.h>
#include <maps/wikimap/mapspro/services/mrc/libs/db/include/feature.h>
#include <maps/wikimap/mapspro/services/mrc/libs/db/include/queued_photo_id.h>
#include <maps/wikimap/mapspro/services/mrc/libs/config/include/config.h>

namespace maps {
namespace mrc {
namespace ride_inspector {

class Context {
public:
    explicit Context(const common::Config& cfg);

    pgpool3::Pool& pool();

    db::rides::QueuedPhotoIds loadQueuedPhotoIds();

    void deleteQueuedPhotoIds(const sql_chemistry::Filter&);

private:
    wiki::common::PoolHolder poolHolder_;
};

} // ride_inspector
} // mrc
} // maps
