#pragma once

#include <maps/wikimap/mapspro/libs/acl_utils/include/feedback.h>
#include <maps/wikimap/mapspro/services/social/src/libs/feedback-actions/tasks_helpers.h>

#include <yandex/maps/wiki/social/common.h>
#include <yandex/maps/wiki/social/rate_limiter.h>
#include <yandex/maps/wiki/social/feedback/enums.h>

namespace maps::wiki::socialsrv {

PostTaskResult resolveTask(
    DbPools& dbPools,
    const acl_utils::FeedbackChecker& feedbackChecker,
    social::TId taskId,
    social::TUid uid,
    social::feedback::Verdict verdict,
    std::optional<social::feedback::RejectReason> rejectReasonOpt,
    const std::string& message);

PostTaskResult resolveTask(
    DbPools& dbPools,
    const acl_utils::FeedbackChecker& feedbackChecker,
    const social::RateLimiter& rateLimiter,
    social::TId taskId,
    social::TUid uid,
    social::feedback::Verdict verdict,
    std::optional<social::feedback::RejectReason> rejectReasonOpt,
    const std::string& message);

} // namespace maps::wiki::socialsrv
