#pragma once

#include <yandex/maps/wiki/social/feedback/task.h>
#include <maps/libs/pgpool/include/pgpool3.h>
#include <yandex/maps/wiki/common/extended_xml_doc.h>
#include <yandex/maps/wiki/common/pgpool3_helpers.h>
#include <yandex/maps/wiki/tasks/status_writer.h>

namespace maps::wiki::social::feedback {

class Worker {
public:
    Worker(const common::ExtendedXmlDoc& cfg,
        tasks::StatusWriter& statusWriter);

    void doTask();

    void doWork();

private:
    size_t setDeployed(
        pqxx::transaction_base& txnCore,
        const Tasks& feedbacks);

    common::PoolHolder socialPool_;
    common::PoolHolder corePool_;
    tasks::StatusWriter& statusWriter_;
};

} // namespace maps::wiki::social::feedback
