#pragma once

#include <cstddef>
#include <string>

namespace maps {
namespace wiki {
namespace contours {

/**
 * \brief partition algorithm settings
 */
struct Params {
    size_t commitsBatchSize;
    size_t minVerticesCount;
    double tolerance;
    std::string idsFile;

    Params()
        : commitsBatchSize(100000)
        , minVerticesCount(1000)
        , tolerance(0.001)
    {}
};

} // contours
} // wiki
} // maps
