#pragma once

#include <maps/wikimap/mapspro/libs/acl/include/user.h>
#include <yandex/maps/wiki/configs/editor/category_groups.h>
#include <yandex/maps/wiki/social/skills.h>

#include <functional>
#include <map>
#include <string>


namespace maps::wiki::skills_updater {

enum class Action { None, Add, Remove };

using Predicate = std::function<
    Action(
        const configs::editor::CategoryGroups&,
        const social::Skills&
    )
>;

extern const std::map<std::string, Predicate> PREDICATES_BY_CATEGORY_GROUPS;

} // maps::wiki::skills_updater
