#pragma once

#include "sample.h"

#include <maps/wikimap/mapspro/libs/types/include/uid.h>
#include <maps/wikimap/mapspro/libs/social/include/yandex/maps/wiki/social/common.h>

#include <pqxx/pqxx>
#include <unordered_map>


namespace maps::wiki::assessment::sampler {

using social::TUids;
using types::TUid;
using StaffLoginToPuid = std::unordered_map<std::string, TUid>;

TUids loadAllowedUids(
    StaffType staffType,
    const std::optional<std::string>& workerConfigPath);

// @note For each staff login result contains only one puid corresponding to an
// arbitrary NMAPS login set in Staff.
StaffLoginToPuid loadStaffLoginToPuidFromYt();

} // maps::wiki::assessment::sampler
