#pragma once

#include <yandex/maps/wiki/common/geom.h>
#include <yandex/maps/wiki/common/geom_utils.h>

#include <maps/libs/geolib/include/bounding_box.h>
#include <maps/libs/geolib/include/vector.h>

#include <vector>
#include <cmath>

namespace maps {
namespace wiki {
namespace signals_graph {

struct Grid {
    Grid(const geolib3::BoundingBox& mercatorBbox, double cellSpan);

    size_t heightCells;
    size_t widthCells;

    double cellSpan;

    std::vector<std::vector<geolib3::BoundingBox>> boxes;
};

} // namespace signals_graph
} // namespace wiki
} // namespace maps
