UNION()

DEFAULT(WIKI_EDITOR_CFG_DIR /usr/share/yandex/maps/wiki/editor)
DEFAULT(YMAPSDF_SCHEMA_DIR /usr/share/yandex/maps/ymapsdf2)
DEFAULT(YMAPSDF_VALIDATION_SQL_DIR /usr/share/yandex/maps/garden/ymapsdf2/validation)

PEERDIR(
    maps/doc/schemas/ymapsdf/garden/validation
    maps/doc/schemas/ymapsdf/package
    maps/wikimap/mapspro/cfg/editor
    maps/wikimap/mapspro/cfg/editor/externals
)

CONFIGURE_FILE(../../export_masstransit/settings.xml.in export_masstransit/settings.xml)
CONFIGURE_FILE(../../export_poi/settings.xml.in export_poi/settings.xml)
CONFIGURE_FILE(../../export_ymapsdf/settings.xml.in export_ymapsdf/settings.xml)

COPY(
    KEEP_DIR_STRUCT

    export_masstransit/cond.xml
    export_masstransit/fix_incomplete.xml
    export_masstransit/fix_ymapsdf.xml
    export_masstransit/ft_source.xml
    export_masstransit/json2ymapsdf.xml
    export_masstransit/mtr_exit.xml
    export_masstransit/mtr_freq.xml
    export_masstransit/mtr_linear.xml
    export_masstransit/mtr_operator.xml
    export_masstransit/mtr_route_alias.xml
    export_masstransit/mtr_route.xml
    export_masstransit/mtr_stop.xml
    export_masstransit/mtr_thread_stop.xml
    export_masstransit/mtr_thread.xml
    export_masstransit/mtr_transition.xml
    export_masstransit/mtr_boarding.xml
    export_masstransit/nm.xml
    export_masstransit/rd.xml
    export_masstransit/skip.xml
    export_masstransit/sql/fix_ymapsdf.sql

    export_poi/fix_incomplete.xml
    export_poi/fix_ymapsdf.xml
    export_poi/json2ymapsdf.xml
    export_poi/poi_attr.xml
    export_poi/poi_nm.xml
    export_poi/poi_parent.xml
    export_poi/skip.xml
    export_poi/vegetation_poi.xml

    export_ymapsdf/addr.xml
    export_ymapsdf/ad.xml
    export_ymapsdf/bld.xml
    export_ymapsdf/business_entrance.xml
    export_ymapsdf/cond.xml
    export_ymapsdf/cond_ds.xml
    export_ymapsdf/dtl.xml
    export_ymapsdf/fix_incomplete.xml
    export_ymapsdf/fix_ymapsdf.xml
    export_ymapsdf/flat_range.xml
    export_ymapsdf/ft_geom.xml
    export_ymapsdf/ft_hd_map.xml
    export_ymapsdf/ft_indoor.xml
    export_ymapsdf/ft_poi.xml
    export_ymapsdf/ft_poi_other.xml
    export_ymapsdf/ft_source.xml
    export_ymapsdf/ft_transport_points.xml
    export_ymapsdf/ft_transport.xml
    export_ymapsdf/ft.xml
    export_ymapsdf/json2ymapsdf.xml
    export_ymapsdf/nm.xml
    export_ymapsdf/rd.xml
    export_ymapsdf/skip.xml
    export_ymapsdf/vehicle_restriction.xml
    export_ymapsdf/zipcode.xml
    export_ymapsdf/sql_fix/0_correct_seq_nums.sql
    export_ymapsdf/sql_fix/ad_to_addr_unity.sql
    export_ymapsdf/sql_fix/arabian_persian_gulf_name.sql
    export_ymapsdf/sql_fix/arrival_points_major.sql
    export_ymapsdf/sql_fix/delete_ad_regions.sql
    export_ymapsdf/sql_fix/default_speed_cat.sql
    export_ymapsdf/sql_fix/rd_id_for_addr_range.sql
    export_ymapsdf/sql_fix/delete_roads_without_nm_or_geom.sql
    export_ymapsdf/sql_fix/generate_metro_exit_names.sql
    export_ymapsdf/sql_fix/fix_mtr.sql
    export_ymapsdf/sql_fix/create_closures_geom.sql
    export_ymapsdf/sql_fix/drop_temporary_columns.sql
    export_ymapsdf/sql_fix/sr_latn_rs_names_as_en.sql
    export_ymapsdf/sql_fix/fix_non_ar_names_in_ps.sql
    export_ymapsdf/sql_fix/indoor_level_union_by_universal.sql
    export_ymapsdf/sql_fix/indoor_roles.sql
    export_ymapsdf/sql_fix/indoor_not_operating.sql
    export_ymapsdf/sql_fix/indoor_poi_disp_class.sql
    export_ymapsdf/sql_fix/rd_el_truck_skeleton_moscow_v_r.sql
    export_ymapsdf/sql_fix/disp_class_navi.sql
    export_ymapsdf/sql_fix/cond_ds.sql
    export_ymapsdf/sql_fix/cond_v_r.sql
    export_ymapsdf/sql_fix/vehicle_restriction_area.sql
    export_ymapsdf/sql_fix/rd_el_speed_limit_truck_RU.sql
    export_ymapsdf/sql_fix/entrance_flat_level.sql
    export_ymapsdf/sql_fix/karabakh_hy_uk_lang_subst.sql
    export_ymapsdf/sql_fix/remove_not_main_entrance_flats.sql
    export_ymapsdf/sql_fix/cond_annotation_self_phrase.sql
    export_ymapsdf/sql_fix/hd_map_p_ft_id.sql
    export_ymapsdf/sql_fix/ad_recognition_default.sql
    export_ymapsdf/sql_fix/ad_hide_and_make_ad_subst.sql

    FROM ${ARCADIA_ROOT}/maps/wikimap/mapspro/tools/ymapsdf-conversion/json2ymapsdf/cfg
)

END()
